diff --git a/game/client/src/main/java/net/minecraft/client/console/syntax/HighlightedRenderer.java b/game/client/src/main/java/net/minecraft/client/console/syntax/HighlightedRenderer.java
new file mode 100644
index 000000000..9ec8047a3
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/console/syntax/HighlightedRenderer.java
@@ -0,0 +1,130 @@
+package net.minecraft.client.console.syntax;
+
+import com.codewaves.codehighlight.core.StyleRenderer;
+import net.minecraft.core.net.command.TextFormatting;
+import org.jetbrains.annotations.NotNull;
+
+import java.util.*;
+
+public class HighlightedRenderer implements StyleRenderer<String> {
+    private static final Map<String, TextFormatting> CLASS_NAME_TO_FORMATTING = new HashMap<>();
+    private static final List<String> KEYWORDS = new ArrayList<>();
+    static {
+        CLASS_NAME_TO_FORMATTING.put("comment", TextFormatting.LIGHT_GRAY);
+        CLASS_NAME_TO_FORMATTING.put("string", TextFormatting.GREEN);
+        CLASS_NAME_TO_FORMATTING.put("number", TextFormatting.LIGHT_BLUE);
+        CLASS_NAME_TO_FORMATTING.put("title", TextFormatting.LIGHT_BLUE);
+        CLASS_NAME_TO_FORMATTING.put("regexp", TextFormatting.RED);
+        CLASS_NAME_TO_FORMATTING.put("doctag", TextFormatting.GREEN);
+        CLASS_NAME_TO_FORMATTING.put("class", TextFormatting.WHITE);
+        CLASS_NAME_TO_FORMATTING.put("function", TextFormatting.LIGHT_BLUE);
+        CLASS_NAME_TO_FORMATTING.put("params", TextFormatting.WHITE);
+        CLASS_NAME_TO_FORMATTING.put("meta", TextFormatting.YELLOW);
+
+        KEYWORDS.addAll(Arrays.asList(
+            "abstract",
+            "assert",
+            "boolean",
+            "break",
+            "byte",
+            "case",
+            "catch",
+            "char",
+            "class",
+            "continue",
+            "const",
+            "default",
+            "do",
+            "double",
+            "else",
+            "enum",
+            "exports",
+            "extends",
+            "final",
+            "finally",
+            "float",
+            "for",
+            "goto",
+            "if",
+            "implements",
+            "import",
+            "instanceof",
+            "int",
+            "interface",
+            "long",
+            "module",
+            "native",
+            "new",
+            "package",
+            "private",
+            "protected",
+            "public",
+            "requires",
+            "return",
+            "short",
+            "static",
+            "strictfp",
+            "super",
+            "switch",
+            "synchronized",
+            "this",
+            "throw",
+            "throws",
+            "transient",
+            "try",
+            "var",
+            "void",
+            "volatile",
+            "while",
+            "null"
+        ));
+    }
+
+    private final @NotNull StringBuilder sb = new StringBuilder();
+
+    @Override
+    public void onStart() {
+        this.sb.setLength(0);
+    }
+
+    @Override
+    public void onFinish() { }
+
+    @Override
+    public void onPushStyle(String style) {
+        this.sb.append(CLASS_NAME_TO_FORMATTING.getOrDefault(style, TextFormatting.WHITE));
+    }
+
+    @Override
+    public void onPopStyle() {
+        this.sb.append(TextFormatting.WHITE);
+    }
+
+    @Override
+    public void onPushCodeBlock(CharSequence codeLexeme) {
+        if (KEYWORDS.contains(codeLexeme.toString())) {
+            this.sb.append(TextFormatting.ORANGE);
+        }
+        this.sb.append(codeLexeme);
+    }
+
+    @Override
+    public void onPushSubLanguage(String name, String code) {
+        this.sb.append(code);
+    }
+
+    @Override
+    public void onPushOriginalSubLanguage(String name, CharSequence code) {
+        this.sb.append(code);
+    }
+
+    @Override
+    public void onAbort(CharSequence code, Exception e) {
+        this.sb.append(code);
+    }
+
+    @Override
+    public String getResult() {
+        return this.sb.toString();
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/console/syntax/RendererFactory.java b/game/client/src/main/java/net/minecraft/client/console/syntax/RendererFactory.java
new file mode 100644
index 000000000..55e846f4a
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/console/syntax/RendererFactory.java
@@ -0,0 +1,11 @@
+package net.minecraft.client.console.syntax;
+
+import com.codewaves.codehighlight.core.StyleRenderer;
+import com.codewaves.codehighlight.core.StyleRendererFactory;
+
+public class RendererFactory implements StyleRendererFactory<String> {
+    @Override
+    public StyleRenderer<String> create(String languageName) {
+        return new HighlightedRenderer();
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/entity/particle/ParticleAsh.java b/game/client/src/main/java/net/minecraft/client/entity/particle/ParticleAsh.java
new file mode 100644
index 000000000..8ff99e5f7
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/entity/particle/ParticleAsh.java
@@ -0,0 +1,34 @@
+package net.minecraft.client.entity.particle;
+
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.core.world.World;
+
+public class ParticleAsh extends Particle {
+    public ParticleAsh(World world, double x, double y, double z, double xa, double ya, double za) {
+        super(world, x, y, z, xa, ya, za);
+        this.xd = xa + (Math.random() * 2D - 1.0D) * 0.05F;
+        this.yd = ya - Math.random() * 2D * 0.2F;
+        this.zd = za + (Math.random() * 2D - 1.0D) * 0.05F;
+        this.rCol = this.gCol = this.bCol = 0.2F + this.random.nextFloat() * 0.3F;
+        this.size = this.random.nextFloat() * this.random.nextFloat() * 6F + 1.0F;
+        this.lifetime = (int) (64 / (this.random.nextFloat() * 0.8D + 0.2D)) + 2;
+    }
+
+    @Override
+    public void tick() {
+        this.xo = this.x;
+        this.yo = this.y;
+        this.zo = this.z;
+        if (this.age++ >= this.lifetime) {
+            this.remove();
+        }
+        this.tex = TextureRegistry.getTexture("minecraft:particle/puff_0");
+        move(this.xd, this.yd, this.zd);
+        this.xd *= 0.9D;
+        this.zd *= 0.9D;
+        if (this.onGround) {
+            this.xd *= 0.7D;
+            this.zd *= 0.7D;
+        }
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/entity/particle/ParticleDispatcher.java b/game/client/src/main/java/net/minecraft/client/entity/particle/ParticleDispatcher.java
index f899c04a5..79b564dad 100644
--- a/game/client/src/main/java/net/minecraft/client/entity/particle/ParticleDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/entity/particle/ParticleDispatcher.java
@@ -37,7 +37,7 @@ public final class ParticleDispatcher extends Dispatcher<String, ParticleLambda>
         INSTANCE = this;
         Minecraft mc = Minecraft.getMinecraft();
         addDispatch("bubble", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleBubble(world, x, y, z, motionX, motionY, motionZ, true));
-        addDispatch("smoke", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleSmoke(world, x, y, z, motionX, motionY, motionX));
+        addDispatch("smoke", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleSmoke(world, x, y, z, motionX, motionY, motionX, 1.0f, data));
         addDispatch("note", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleNote(world, x, y, z, motionX, motionY, motionX, data));
         addDispatch("portal", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticlePortal(world, x, y, z, motionX, motionY, motionX, data));
         addDispatch("explode", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleExplode(world, x, y, z, motionX, motionY, motionX));
@@ -47,7 +47,7 @@ public final class ParticleDispatcher extends Dispatcher<String, ParticleLambda>
         addDispatch("lava", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleLava(world, x, y, z));
         addDispatch("footstep", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleFootstep(mc.textureManager, world, x, y, z));
         addDispatch("splash", (world1, d, d1, d2, d3, d4, d5, data) -> new ParticleSplash(world1, d, d1, d2, d3, d4, d5));
-        addDispatch("largesmoke", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleSmoke(world, x, y, z, motionX, motionY, motionX, 2.5f));
+        addDispatch("largesmoke", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleSmoke(world, x, y, z, motionX, motionY, motionX, 2.5f, data));
         addDispatch("puffrgb", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticlePuffRGB(world, x, y, z, (float) motionX, (float) motionY, (float) motionZ, data));
         addDispatch("reddust", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleRedstoneDust(world, x, y, z, data));
         addDispatch("item", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleItemBreaking(world, x, y, z, Item.itemsList[MathHelper.clamp(data, 0, Item.itemsList.length - 1)]));
@@ -77,5 +77,6 @@ public final class ParticleDispatcher extends Dispatcher<String, ParticleLambda>
             return new ParticleFluidDrip(world, x, y, z, color, TextureRegistry.getTexture("minecraft:block/water_flowing"));
         });
         addDispatch("dripLava", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleFluidDrip(world, x, y, z, 0xFFFFFF, TextureRegistry.getTexture("minecraft:block/lava_flowing")).setFullBright());
+        addDispatch("ashmote", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleAsh(world, x, y, z, 0, 0, 0));
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/entity/particle/ParticleSmoke.java b/game/client/src/main/java/net/minecraft/client/entity/particle/ParticleSmoke.java
index 55dfd2fdc..bf1b54e76 100644
--- a/game/client/src/main/java/net/minecraft/client/entity/particle/ParticleSmoke.java
+++ b/game/client/src/main/java/net/minecraft/client/entity/particle/ParticleSmoke.java
@@ -7,11 +7,7 @@ import net.minecraft.core.world.World;
 public class ParticleSmoke extends Particle {
     private final float oSize;
 
-    public ParticleSmoke(World world, double x, double y, double z, double xa, double ya, double za) {
-        this(world, x, y, z, xa, ya, za, 1.0F);
-    }
-
-    public ParticleSmoke(World world, double x, double y, double z, double xa, double ya, double za, float scale) {
+    public ParticleSmoke(World world, double x, double y, double z, double xa, double ya, double za, float scale, int data) {
         super(world, x, y, z, 0.0D, 0.0D, 0.0D);
         this.xd *= 0.1D;
         this.yd *= 0.1D;
@@ -19,7 +15,11 @@ public class ParticleSmoke extends Particle {
         this.xd += xa;
         this.yd += ya;
         this.zd += za;
-        this.rCol = this.gCol = this.bCol = (float) (Math.random() * 0.3D);
+        if (data == 1) {
+            this.rCol = this.gCol = this.bCol = (float) (1.0 - (Math.random() * 0.2));
+        } else {
+            this.rCol = this.gCol = this.bCol = (float) (Math.random() * 0.3D);
+        }
         this.size *= 0.75F;
         this.size *= scale;
         this.oSize = this.size;
diff --git a/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java b/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java
index 20561faeb..a85d80004 100644
--- a/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java
+++ b/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java
@@ -20,6 +20,7 @@ import net.minecraft.client.gui.container.ScreenTrommel;
 import net.minecraft.client.gui.ScreenWandMobPicker;
 import net.minecraft.client.gui.guidebook.ScreenGuidebook;
 import net.minecraft.client.input.PlayerInput;
+import net.minecraft.client.render.worldtype.WorldTypeFXDispatcher;
 import net.minecraft.core.achievement.Achievement;
 import net.minecraft.core.achievement.Achievements;
 import net.minecraft.core.achievement.stat.Stat;
@@ -38,6 +39,7 @@ import net.minecraft.core.data.gamerule.GameRules;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.entity.vehicle.EntityBoat;
+import net.minecraft.core.entity.vehicle.MobGhastVehicle;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.client.net.command.ClientCommandSource;
@@ -229,6 +231,8 @@ public class PlayerLocal extends Player
         {
            mc.ppm.update();
         }
+
+        WorldTypeFXDispatcher.getInstance().getDispatch(world.getWorldType()).playerAnimationTick(world, this);
     }
     
     @Override
@@ -528,5 +532,8 @@ public class PlayerLocal extends Player
         if (vehicle instanceof EntityBoat) {
             ((EntityBoat) vehicle).controlBoat(-input.moveForward, -input.moveStrafe);
         }
+        if (vehicle instanceof MobGhastVehicle) {
+            ((MobGhastVehicle) vehicle).controlVehicle(-input.moveForward, -input.moveStrafe, input.jump, input.sneak);
+        }
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ButtonElement.java b/game/client/src/main/java/net/minecraft/client/gui/ButtonElement.java
index 2776c44ff..5e8331a98 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ButtonElement.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ButtonElement.java
@@ -3,7 +3,10 @@ package net.minecraft.client.gui;
 import net.minecraft.client.render.Font;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.client.render.window.CursorShape;
+import net.minecraft.client.render.window.GameWindowGLFW;
 import org.jetbrains.annotations.Nullable;
+import org.lwjgl.glfw.GLFW;
 import org.lwjgl.opengl.GL11;
 
 import net.minecraft.client.Minecraft;
@@ -88,6 +91,10 @@ public class ButtonElement extends Gui implements GuiElement
         boolean mouseOver = mouseX >= xPosition && mouseY >= yPosition && mouseX < xPosition + width && mouseY < yPosition + height;
         int state = getButtonState(mouseOver);
 
+        if (mouseOver && visible && enabled) {
+            mc.currentScreen.setDesiredCursor(CursorShape.HAND);
+        }
+
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
         IconCoordinate tex;
         switch (state) {
@@ -107,12 +114,13 @@ public class ButtonElement extends Gui implements GuiElement
 
         int textColor;
         switch (state) {
-            case 0:
+            case STATE_DISABLED:
                 textColor = 0xA0A0A0;
                 break;
-            case 1:
+            case STATE_DEFAULT:
                 textColor = 0xE0E0E0;
                 break;
+            case STATE_HOVERED:
             default:
                 textColor = 0xFFFFA0;
                 break;
@@ -143,6 +151,16 @@ public class ButtonElement extends Gui implements GuiElement
     	return this;
     }
 
+    public ButtonElement mute() {
+        this.playSound = false;
+        return this;
+    }
+
+    public ButtonElement hide() {
+        this.visible = false;
+        return this;
+    }
+
 	@Override
 	public void setX(int x) {
 		this.xPosition = x;
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ClickableLabelElement.java b/game/client/src/main/java/net/minecraft/client/gui/ClickableLabelElement.java
index d634da271..cd24b7bca 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ClickableLabelElement.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ClickableLabelElement.java
@@ -2,6 +2,7 @@ package net.minecraft.client.gui;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.Font;
+import net.minecraft.client.render.window.CursorShape;
 import org.lwjgl.opengl.GL11;
 
 public class ClickableLabelElement extends ButtonElement
@@ -55,9 +56,14 @@ public class ClickableLabelElement extends ButtonElement
         {
             return;
         }
+
+        boolean hovered = mouseX >= xPosition && mouseY >= yPosition && mouseX < xPosition + width && mouseY < yPosition + height;
+        if (hovered && enabled) {
+            mc.currentScreen.setDesiredCursor(CursorShape.HAND);
+        }
+
         Font font = mc.font;
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-        boolean hovered = mouseX >= xPosition && mouseY >= yPosition && mouseX < xPosition + width && mouseY < yPosition + height;
         width = font.getStringWidth(displayString) + 4;
         drawRect(xPosition, yPosition, xPosition + width, yPosition + height, enabled ? (hovered ? 0x7F8080C0 : bgColor) : 0x00000000);
         if (enabled && (shadow || hovered)) {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/Screen.java b/game/client/src/main/java/net/minecraft/client/gui/Screen.java
index c5045b9f9..02e9df1ab 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/Screen.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/Screen.java
@@ -9,23 +9,27 @@ import net.minecraft.client.Minecraft;
 import net.minecraft.client.input.controller.ControllerInput;
 import net.minecraft.client.render.Font;
 import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.window.CursorShape;
+import net.minecraft.client.render.window.GameWindowGLFW;
 import net.minecraft.client.util.debug.DebugRender;
 import net.minecraft.client.input.InputType;
 
 import net.minecraft.core.sound.SoundCategory;
+import org.lwjgl.glfw.GLFW;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.input.Mouse;
 import org.lwjgl.opengl.GL11;
 
 public abstract class Screen extends Gui {
-    protected Minecraft mc;
+    public Minecraft mc;
     public int width;
     public int height;
     public List<ButtonElement> buttons;
     public boolean passEvents;
-    protected Font font;
+    public Font font;
     protected ButtonElement clickedButton;
     final Screen parentScreen;
+    private CursorShape desiredCursor = CursorShape.ARROW;
 
     public Screen(Screen parent) {
         buttons = new ArrayList<>();
@@ -42,6 +46,14 @@ public abstract class Screen extends Gui {
         return parentScreen;
     }
 
+    public final CursorShape getDesiredCursor() {
+        return this.desiredCursor;
+    }
+
+    public final void setDesiredCursor(CursorShape desiredCursor) {
+        this.desiredCursor = desiredCursor;
+    }
+
     public <E extends ButtonElement> E add(E button) {
         buttons.add(button);
         return button;
@@ -134,6 +146,10 @@ public abstract class Screen extends Gui {
                     mc.gameWindow.toggleFullscreen();
                     return;
                 }
+                if (!(this instanceof ScreenConsole) && eventKey == mc.gameSettings.keyShowConsole.getKeyCode()) {
+                    mc.displayScreen(new ScreenConsole(this));
+                    return;
+                }
                 keyPressed(eventChar, eventKey, mouseX, mouseY);
             }
         }
@@ -171,6 +187,7 @@ public abstract class Screen extends Gui {
     }
 
     public void drawControllerCursor() {
+        if (mc.controllerInput.hideCursor) return;
         glDisable(GL_DEPTH_TEST);
         glEnable(GL_BLEND);
         glColor3d(1.0, 1.0, 1.0);
@@ -185,15 +202,35 @@ public abstract class Screen extends Gui {
 
     public void playControllerButtonSound(ControllerInput controller) {
         if (controller.buttonA.pressedThisFrame() || controller.buttonX.pressedThisFrame() || controller.buttonY.pressedThisFrame()) {
-            mc.sndManager.playSound("random.ui_click", SoundCategory.GUI_SOUNDS, 1.0f, 1.0f);
+            mc.sndManager.playSound("ui.ui_click", SoundCategory.GUI_SOUNDS, 1.0f, 1.0f);
         }
         if (controller.buttonB.pressedThisFrame()) {
-            mc.sndManager.playSound("random.ui_back", SoundCategory.GUI_SOUNDS, 1.0f, 1.0f);
+            mc.sndManager.playSound("ui.ui_back", SoundCategory.GUI_SOUNDS, 1.0f, 1.0f);
         }
     }
 
     public void guiSpecificControllerInput(ControllerInput controller) {
-
+        if(controller.buttonB.pressedThisFrame()) {
+            this.keyPressed((char)0, Keyboard.KEY_BACK, -1, -1);
+        }
+        if(controller.buttonStart.pressedThisFrame()) {
+            this.keyPressed((char)0, Keyboard.KEY_ESCAPE, -1, -1);
+        }
+        if(controller.buttonA.pressedThisFrame()) {
+            this.mouseClicked((int)controller.cursorX, (int)controller.cursorY, 0);
+        }
+        if(controller.buttonA.releasedThisFrame()) {
+            this.mouseReleased((int)controller.cursorX, (int)controller.cursorY, 0);
+        }
+        if(controller.buttonY.pressedThisFrame()) {
+            this.mouseClicked((int)controller.cursorX, (int)controller.cursorY, 1);
+        }
+        if(controller.buttonY.releasedThisFrame()) {
+            this.mouseReleased((int)controller.cursorX, (int)controller.cursorY, 1);
+        }
+        if(controller.buttonX.pressedThisFrame()) {
+            this.mouseClicked((int)controller.cursorX, (int)controller.cursorY, 10);
+        }
     }
 
     public boolean isPauseScreen() {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenAddServer.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenAddServer.java
index 6be2b2ce9..ae8734f2e 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenAddServer.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenAddServer.java
@@ -139,7 +139,9 @@ public class ScreenAddServer extends Screen
         drawString(font, stringtranslate.translateKey("gui.add_server.label.server_name"), serverNameTextField.xPosition, serverNameTextField.yPosition - 14, 0xa0a0a0);
         drawString(font, stringtranslate.translateKey("gui.add_server.label.ip_address"), ipTextField.xPosition, ipTextField.yPosition - 14, 0xa0a0a0);
         ipTextField.drawTextBox();
+        ipTextField.updateCursor(mc, mx, my);
         serverNameTextField.drawTextBox();
+        serverNameTextField.updateCursor(mc, mx, my);
         super.render(mx, my, partialTick);
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenConnectToIp.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenConnectToIp.java
index 57bfb92f1..307ef8273 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenConnectToIp.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenConnectToIp.java
@@ -87,6 +87,7 @@ public class ScreenConnectToIp extends Screen
         drawStringCentered(font, i18n.translateKey("gui.connect_to_ip.label.title"), width / 2, (height / 4 - 60) + 20, 0xffffff);
         drawString(font, i18n.translateKey("gui.connect_to_ip.label.enter_ip"), width / 2 - 140, (height / 4 - 60) + 60 + 36, 0xa0a0a0);
         textField.drawTextBox();
+        textField.updateCursor(mc, mx, my);
         super.render(mx, my, partialTick);
     }
 
